<template>
  <div id="user-info">
    <div class="backIcon" @click="goBack">
        <i class="icon-font-v1 icon-font-fanhui"></i>
    </div>
    <div style="height: 122px;width: 1px"/>
    <div class="content">
      <el-avatar class="avatar" :src="userInfo.avatar"/>
      <div class="big-btn">
        <el-button round size="small" v-if="userRelation===0" @click="switchFollow"><i class="icon-font-v1 icon-font-adduser"/>关注</el-button>
        <el-button round size="small" v-if="userRelation===10" @click="switchFollow"><i class="icon-font-v1 icon-font-deleteuser"/>已关注</el-button>
        <el-button round size="small" v-if="userRelation===11" @click="switchFollow"><i class="icon-font-v1 icon-font-deleteuser"/>已互关</el-button>
        <el-button round size="small" v-if="userRelation===1" @click="switchFollow"><i class="icon-font-v1 icon-font-adduser"/>关注</el-button>
      </div>
      <div class="box" id="basic">
        <div class="text-info">
          <div style="color: #3D3D3D;font-size: 18px;font-weight: bold;margin-bottom: 7px">{{userInfo.nickName}}</div>
          <div style="color: #7C7C7C;font-size: 12px;margin-bottom: 12px">{{userInfo.gender===0?'女':(userInfo.gender===1?'男':'')}}&nbsp;{{userInfo.univ}}&nbsp;</div>
          <div style="color: #424242;font-size: 12px">{{userInfo.note}}</div>
        </div>
        <div style="width: 100%;height: 1px;background-color: #D5D5D5"/>
        <router-link class="follow-info" :to="`/followList?id=${userInfo.id}`">
          <div style="color: #3170FF; font-size: 20px;font-weight: bold">{{userInfo.followerNum}}</div>
          <div style="color: #646464; font-size: 12px;margin-left: 12px">关注Ta的人</div>
          <div style="color: #3170FF; font-size: 20px;font-weight: bold;margin-left: 28px">{{userInfo.followedNum}}</div>
          <div style="color: #646464; font-size: 12px;margin-left: 12px">Ta关注的人</div>
        </router-link>
        <div style="width: 100%;height: 1px;background-color: #D5D5D5"/>
        <div class="tag-info">
          <div v-for="(tag,tagIndex) in userInfo.tags" :key="tagIndex" class="tag">{{tag}}</div>
        </div>
      </div>
      <div class="box" id="boards">
        <el-tabs v-model="selectedBoard" stretch>
          <el-tab-pane label="ta 发布的" name="created">
            <div v-for="(board, index) in userInfo.createdBoard" :key="index" class="board" @click="routeTo('/boardDetail?id='+board.id)">
              <div class="title">{{board.title}}</div>
              <div class="content-text">{{board.content}}</div>
              <div class="time">发布于 {{board.time}}</div>
            </div>
          </el-tab-pane>
          <el-tab-pane label="ta 参与的" name="taken">
            <div v-for="(board, index) in userInfo.takenBoards" :key="index" class="board" @click="routeTo('/boardDetail?id='+board.id)">
              <div class="title">{{board.title}}</div>
              <div class="content-text">{{board.content}}</div>
              <div class="time">发布于 {{board.time}}</div>
            </div>
          </el-tab-pane>
          <el-tab-pane label="ta 收藏的" name="collected">
            <div v-for="(board, index) in userInfo.collectedBoards" :key="index" class="board" @click="routeTo('/boardDetail?id='+board.id)">
              <div class="title">{{board.title}}</div>
              <div class="content-text">{{board.content}}</div>
              <div class="time">发布于 {{board.time}}</div>
            </div>
          </el-tab-pane>
        </el-tabs>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'UserInfo',
  data () {
    return {
      userInfo: {
        avatar: '',
        nickName: 'nickName',
        gender: 1,
        univ: '2017级 同济大学 软件学院',
        note: '一个普通的大学生',
        followerNum: 2,
        followedNum: 144,
        tags: ['考研', '自习联盟', 'IT', '攀岩'],
        createdBoard: [
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          },
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          },
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          }
        ],
        takenBoards: [
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          }
        ],
        collectedBoards: [
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          },
          {
            title: '周五下午图书馆放弃手机自习活动，约一个妹子啦啦啦啦啦啦~',
            content: '如题，甚至以后可以当长时间的自习伙伴！一起进步鸭！嘿嘿嘿嘿嘿嘿！',
            time: '2019/10/23 12:50'
          }
        ]
      },
      userRelation: 0,
      selectedBoard: 'created'
    }
  },
  methods: {
    goBack () {
      this.$router.go(-1)
    },
    routeTo (path) {
      this.$router.push(path)
    },
    switchFollow () {
      if (this.myInfo == null) {
        this.$message.info('请先登录')
        return
      }
      if (this.userRelation >= 10) {
        this.$api.unfollow(this.userInfo.id)
          .then(res => {
            this.$message.success('取关成功！')
            this.userRelation -= 10
          })
      } else {
        this.$api.follow(this.userInfo.id)
          .then(res => {
            this.$message.success('关注成功！')
            this.userRelation += 10
          })
      }
    }
  },
  mounted () {
    let params = this.$route.query
    let id = params['userId'] ? params['userId'] : params['id']
    if (id) {
      this.$api.userInfo(id)
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            id: id,
            avatar: data.profilePhotoUrl,
            nickName: data.name,
            gender: data.sexual,
            univ: data.university + data.college,
            note: data.introduction
          }
          return this.$api.getUserFollowerNum(id)
        })
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            ...this.userInfo,
            followerNum: data.followers,
            followedNum: data.followings
          }
          return this.$api.getUserTags(id)
        })
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            ...this.userInfo,
            tags: data.map(item => item.name)
          }
          return this.$api.getMyBoards(id)
        })
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            ...this.userInfo,
            createdBoard: data.map(item => {
              return {
                id: item.id,
                title: item.title,
                content: item.content,
                time: item.gmtCreate
              }
            })
          }
          return this.$api.getMyAttendBoards(id)
        })
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            ...this.userInfo,
            takenBoards: data.map(item => {
              return {
                id: item.id,
                title: item.title,
                content: item.content,
                time: item.gmtCreate
              }
            })
          }
          return this.$api.getMyFavoriteBoards(id)
        })
        .then(res => {
          let data = res.data.data
          this.userInfo = {
            ...this.userInfo,
            collectedBoards: data.map(item => {
              return {
                id: item.id,
                title: item.title,
                content: item.content,
                time: item.gmtCreate
              }
            })
          }
        })
      if (this.myInfo) {
        if(id==this.myInfo.userId){
            this.userRelation = 5
        }else{
            this.$api.getFollowRelation(this.myInfo.userId, id)
              .then(res => {
                let data = res.data.data
                console.log(data)
                this.userRelation = data.isFollowing * 10 + data.isFollower
            })
        }
      }
    }
  },
  computed: {
    myInfo () {
      return this.$store.state.userInfo.detail
    }
  }
}
</script>

<style scoped lang="less">
#user-info {
  width: 100vw;
  height: 100vh;
  background-color: #3F72F6;
  position: relative;
  .backIcon {
    position: absolute;
    width: 13.5px;
    height: 18.5px;
    left: 10px;
    top: 20px;
    i{
        font-size: 30px;
        color: #ffffff;
    }
  }
  .content {
    display: flex;
    position: relative;
    flex-direction: column;
    align-items: stretch;
    min-height: calc(100vh - 122px);
    background-color: #DEDEDE;
    border-radius: 7.5px;
    overflow: visible;
    .avatar {
      position: absolute;
      height: 96px;
      width: 96px;
      top: -48px;
      left: 13px;
    }
    .big-btn{
        position:absolute;
        // width: 120px;
        /*height: 21px;*/
        right: 13px;
        top: 13px;
        .icon-font-v1{
            color: #3170FF;
            font-size: 16px;
            margin-right:5px;
        }
    }
    .box {
      background-color: white;
      &:nth-child(1n+4) {
        margin-top: 9px;
      }
      &#basic {
        padding: 70px 12px 20px 12px;
        border-top-left-radius: 7.5px;
        border-top-right-radius: 7.5px;
        .text-info {
          padding-left: 20px;
          margin-bottom: 24px;
        }
        .follow-info {
          display: flex;
          flex-direction: row;
          align-items: center;
          padding: 20px 0 20px 22px;
        }
        .tag-info {
          display: flex;
          flex-direction: row;
          overflow: hidden;
          padding-left: 18px;
          padding-top: 20px;
          .tag {
            padding: 9px 7px 9px 10px;
            font-size: 13px;
            font-weight: bold;
            border: #3170FF 2px solid;
            border-radius: 4px;
            letter-spacing: 3px;
            &:nth-child(1n+2) {
              margin-left: 11px;
            }
          }
        }
      }
      &#boards {
        flex: 1;
        padding: 0 14px 20px 14px;
        .board {
          padding: 15px 13px 20px 13px;
          display: flex;
          flex-direction: column;
          .title {
            color: #333;
            font-size: 15px;
            font-weight: bold;
            align-self: flex-start;
            margin-bottom: 8px;
          }
          .content-text {
            color: #7c7c7c;
            font-size: 13px;
            align-self: flex-start;
            margin-bottom: 15px;
          }
          .time {
            color: #acacac;
            font-size: 9px;
            align-self: flex-end;
          }
          &:nth-child(1n+2) {
            border-top: 1px #d5d5d5 solid;
          }
        }

      }
    }
  }
}
</style>
